% (i)
f1 = @(x) 1./(2.*x.^3 - x.^2).*(5.*sin(20./x)).^2;
a = 1.5;
b = 4.;
tol = 1.e-4;
maxlevel = 12;
[Q,grid] = adaptsimp(f1,a,b,tol,maxlevel);
x = linspace(a,b,1000);
clf;
plot(x,f1(x),'b-');
hold on;
plot(grid,0.*grid,'r+');
title('(i)');
ylim([-0.1,3]);
xlabel('x');
ylabel('y');
hold off;
print('adaptiv_experience_1.eps','-depsc')
pause;

% (ii)
f2 = @(x) min(f1(x),0.5);
a = 1.5;
b = 4.;
tol = 1.e-4;
maxlevel = 12;
[Q,grid] = adaptsimp(f2,a,b,tol,maxlevel);
x = linspace(a,b,1000);
clf;
plot(x,f2(x),'b-');
hold on;
plot(grid,0.*grid,'r+');
ylim([-0.1,3]);
title('(ii)');
xlabel('x');
ylabel('y');
hold off;
print('adaptiv_experience_2.eps','-depsc')
pause;

% (iii)
f3 = @(x) 1./(1. + x.^2);
a = -5.;
b = +5.;
tol = 1.e-4;
maxlevel = 12;
[Q,grid] = adaptsimp(f3,a,b,tol,maxlevel);
x = linspace(a,b,1000);
clf;
plot(x,f3(x),'b-');
hold on;
plot(grid,0.*grid,'r+');
ylim([-0.1,1.2]);
title('(iii)');
xlabel('x');
ylabel('y');
hold off;
print('adaptiv_experience_3.eps','-depsc')
pause;

% (iv)
f4 = @(x) sqrt(x);
a = 0.;
b = 1.;
tol = 1.e-4;
maxlevel = 12;
[Q,grid] = adaptsimp(f4,a,b,tol,maxlevel);
x = linspace(a,b,1000);
clf;
plot(x,f4(x),'b-');
hold on;
plot(grid,0.*grid,'r+');
ylim([-0.1,1.2]);
title('(iv)');
xlabel('x');
ylabel('y');
hold off;
print('adaptiv_experience_4.eps','-depsc')
pause;

% (v)
f5 = @(x) sin(4.*pi*x).*exp(-2.*x);
a = 0.;
b = 1.;
tol = 1.e-4;
maxlevel = 12;
[Q,grid] = adaptsimp(f5,a,b,tol,maxlevel);
x = linspace(a,b,1000);
clf;
plot(x,f5(x),'b-');
hold on;
plot(grid,0.*grid,'r+');
title('(v)');
xlabel('x');
ylabel('y');
hold off;
print('adaptiv_experience_5.eps','-depsc')
pause;

% (vi)
f6 = @(x) sin(4.*pi*x).*exp(-2.*x);
a = 0.0;
c = 0.6;
b = 1.0;
tol = 1.e-4;
maxlevel = 12;
[Q1,grid1] = adaptsimp(f5,a,c,tol,maxlevel);
[Q2,grid2] = adaptsimp(f5,c,b,tol,maxlevel);
x = linspace(a,b,1000);
clf;
plot(x,f6(x),'b-');
hold on;
plot(grid1,0.*grid1,'r+');
plot(grid2,0.*grid2,'g+');
title('(vi)');
xlabel('x');
ylabel('y');
hold off;
print('adaptiv_experience_6.eps','-depsc')

